
#include <stdio.h>
#include "cell.h"

extern void	Error();

#define BYTE		unsigned char
#define TEXT_LEN	256
#define PV		(int)((Cell)(~0))

void	ColorFile(path,solid,R,G,B)
char	*path,*solid;
BYTE	*R,*G,*B;
{
	FILE	*file;
	int	pv,pv1,pv2,R1,G1,B1,R2,G2,B2;
	char	text[TEXT_LEN];
	double	d0,d1,d2;

	if (path[0]=='-')
	    file=stdin;
	else
	    if ((file=fopen(path,"r"))==NULL) {
		(void)fputs(path,stderr); Error(" : file not found.");
	    }

	solid[0]=0;
	for (pv=1; pv<=PV; pv++) {
	    solid[pv]=1; R[pv]=G[pv]=B[pv]=255;
	}
	while (fgets(text,TEXT_LEN,file)!=NULL) {
	    switch(sscanf(text,"%d %d %d %d %d %d %d %d",
			       &pv1,&pv2,&R1,&G1,&B1,&R2,&G2,&B2)) {
		case EOF: goto Break;
		case 1: pv=0; pv2=pv1; break;
		case 2: pv=0; break;
		case 4: pv=1; B2=B1=G1; G2=G1=R1; R2=R1=pv2; pv2=pv1; break;
		case 5: pv=1; B2=B1; G2=G1; R2=R1; break;
		case 8: pv=1; break;
		default: Error("bad color parameter.");
	    }
	    if (pv1<0 || pv2>PV || pv1>pv2) Error("bad pixel value range.");

	    if (!pv)
		for (pv=pv1; pv<=pv2; pv++) solid[pv]=0;
	    else {
		if (R1<0 || R1>255 || R2<0 || R2>255 ||
		    G1<0 || G1>255 || G2<0 || G2>255 ||
		    B1<0 || B1>255 || B2<0 || B2>255) Error("bad RGB value.");

		if (pv1==pv2) {
		    solid[pv1]=1; R[pv1]=(BYTE)R1;
				  G[pv1]=(BYTE)G1;
				  B[pv1]=(BYTE)B1;
		}
                else {
		    d0=(double)(pv2-pv1);
		    for (pv=pv1; pv<=pv2; pv++) {
			d1=(double)(pv2-pv)/d0;
			d2=(double)(pv-pv1)/d0;
			solid[pv]=1; R[pv]=(BYTE)((double)R1*d1+(double)R2*d2);
				     G[pv]=(BYTE)((double)G1*d1+(double)G2*d2);
				     B[pv]=(BYTE)((double)B1*d1+(double)B2*d2);
		    }
		}
            }
	}
Break:;
	if (file!=stdin) (void)fclose(file);
}
