
#include <stdio.h>
#include <stdlib.h>
#include "sgif.h"

#define UCHAR	unsigned char

UCHAR	StoreGIF_Gray[256]={
	  0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
	 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31,
	 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47,
	 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63,
	 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 79,
	 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95,
	 96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111,
	112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,
	128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143,
	144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159,
	160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175,
	176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191,
	192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207,
	208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223,
	224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239,
	240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255};

static void	Error(msg)
char		*msg;
{
	(void)fputs(msg,stderr); (void)fputs(" error.\n",stderr); exit(1);
}

static void	fPutC(byte,file)
int		byte;
FILE		*file;
{
	if (fputc(byte,file)!=byte) Error("byte write");
}

#define FPUTC(byte,file)	fPutC((int)(byte),file)
#define FPUTW(word,file)	FPUTC(word&0xff,file); FPUTC(word>>8,file)

static void	fWrite(bytes,size,items,file)
void		*bytes;
size_t		size,items;
FILE		*file;
{
	if (fwrite(bytes,size,items,file)!=items) Error("bytes write");
}

#define FWRITE(bytes,size,items,file)	\
	fWrite(bytes,(size_t)(size),(size_t)(items),file)

void	InitStoreGIF(file,Nx,Ny,cmR,cmG,cmB)
FILE	*file;
int	Nx,Ny;
UCHAR	*cmR,*cmG,*cmB;
{
	int	idx;

	FWRITE("GIF87a",1,6,file);
	FPUTW(Nx,file);
	FPUTW(Ny,file);
	if (cmR!=NULL && cmG!=NULL && cmB!=NULL) {
	    FPUTC(0xf0|(8-1),file);
	    FPUTC(0,file);
	    FPUTC(0,file);
	    for (idx=0; idx<256; idx++) {
		FPUTC(cmR[idx],file);
		FPUTC(cmG[idx],file);
		FPUTC(cmB[idx],file);
	    }
	}
	else {
	    FPUTC(0x70|(8-1),file);
	    FPUTC(0,file);
	    FPUTC(0,file);
	}
}

static long	buf;
static int	num,len;
static UCHAR	out[256];

static void	Put(code,file)
int		code;
FILE		*file;
{
	buf|=((long)code<<num);
	for (num+=len; num>=8; num-=8) {
	    out[++(*out)]=(UCHAR)(buf&0xff); buf>>=8;
	    if (*out==255) {
		FWRITE(out,1,256,file); *out=0;
	    }
	}
}

static long	str[9001];
static int	ent,roof,head;

static void	InitEncode(file)
FILE		*file;
{
	int	idx;

	FPUTC(8,file);

	buf=0; num=0; len=9; *out=0; Put(256,file);
	for (idx=0; idx<9001; idx++) str[idx]=0;
	ent=258; roof=512; head=4096;
}

static void	Encode(tail,file)
int		tail;
FILE		*file;
{
	long	h_t;
	int	idx,step;

	if (head!=4096) {
	    h_t=(((long)head<<8)|tail)<<12;
	    if (str[idx=head^(tail<<5)]!=0) {
		if ((str[idx]&0xfffff000)==h_t) {
		    head=(int)(str[idx]&0xfff); return;
		}
		step=(idx==0)?9000:idx;
		while (str[idx=(idx+step)%9001]!=0)
		    if ((str[idx]&0xfffff000)==h_t) {
			head=(int)(str[idx]&0xfff); return;
		    }
	    }
	    Put(head,file);
	    if (ent!=4096) {
		str[idx]=h_t|ent;
		if (ent==roof) {
		    ++len; roof<<=1;
		}
		++ent;
	    }
	    else {
		Put(256,file); len=9;
		for (idx=0; idx<9001; idx++) str[idx]=0;
		ent=258; roof=512;
	    }
	}
	head=tail;
}

static void	TermEncode(file)
FILE		*file;
{
	if (head!=4096) {
	    Put(head,file); if (ent==roof) ++len;
	}
	Put(257,file);

	if (num!=0) out[++(*out)]=(UCHAR)buf;

	if (*out!=0) FWRITE(out,1,(int)*out+1,file);

	FPUTC(0,file);
}

void	StoreGIF(file,xO,yO,Nx,Ny,cmR,cmG,cmB,pv)
FILE	*file;
int	xO,yO,Nx,Ny;
UCHAR	*cmR,*cmG,*cmB,**pv;
{
	int	idx,x,y;

	FPUTC(',',file);
	FPUTW(xO,file);
	FPUTW(yO,file);
	FPUTW(Nx,file);
	FPUTW(Ny,file);
	if (cmR!=NULL && cmG!=NULL && cmB!=NULL) {
	    FPUTC(0x80|(8-1),file);
	    for (idx=0; idx<256; idx++) {
		FPUTC(cmR[idx],file);
		FPUTC(cmG[idx],file);
		FPUTC(cmB[idx],file);
	    }
	}
	else
	    FPUTC(8-1,file);

	InitEncode(file);

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) Encode((int)pv[y][x],file);

	TermEncode(file);
}

typedef union {
		struct {
			UCHAR	rgb[3];
		} array;
		long		code;
	} Color;

#define RGB	array.rgb

#define ULONG	unsigned long

typedef struct List {
		Color		color;
		union {
			ULONG	count;
			int	index;
		} u;
		struct List	*next;
	} List;

#define COUNT	u.count
#define INDEX	u.index

static ULONG	Bisect(LUT,lower,upper,rgb012,pivot)
List		**LUT;
ULONG		lower,upper;
int		rgb012;
UCHAR		pivot;
{
	ULONG	i,j;
	List	*tmp;

	for (i=lower; i<upper; i++)
	    if (LUT[i]->color.RGB[rgb012]>=pivot) break;

	for (j=i+1; j<upper; j++)
	    if (LUT[j]->color.RGB[rgb012]<pivot) {
		tmp=LUT[i]; LUT[i]=LUT[j]; LUT[j]=tmp; ++i;
	    }

	return i;
}

typedef struct {
		ULONG	count,lower,upper;
		UCHAR	width,Rbase,Gbase,Bbase;
	} Cube;

static void	Register(cube,LUT,lower,upper,width,Rbase,Gbase,Bbase)
Cube		*cube;
List		**LUT;
ULONG 		lower,upper;
UCHAR		width,Rbase,Gbase,Bbase;
{
	ULONG	i;

	while (cube->count!=0) ++cube;

	for (i=lower; i<upper; i++) cube->count+=LUT[i]->COUNT;

	if ((cube->lower=lower)==(cube->upper=upper)-1)
	    cube->width=0;
	else {
	    cube->width=width;
	    cube->Rbase=Rbase; cube->Gbase=Gbase; cube->Bbase=Bbase;
	}
}

#ifndef	SHIFT
#define SHIFT	4
#endif

#define SIZE	(1<<SHIFT)

#ifdef	HASH
#define MASK(rgb)	((rgb)&(SIZE-1))
#else
#define MASK(rgb)	((rgb)>>(8-SHIFT))
#endif

void	StoreGIF_RGB(file,xO,yO,Nx,Ny,pvR,pvG,pvB)
FILE	*file;
int	xO,yO,Nx,Ny;
UCHAR	**pvR,**pvG,**pvB;
{
	int	r,g,b,x,y,i,j,new=0;
	List	*top[SIZE][SIZE][SIZE],**ptr,*list,**LUT,*next;
	Color	color;
	ULONG	l,u,R,G,B,c,k,old=0;
	Cube	cube[256];
	UCHAR	width,Rp,Gp,Bp,Rb,Gb,Bb;
	double	Rs,Gs,Bs,count;

	FPUTC(',',file);
	FPUTW(xO,file);
	FPUTW(yO,file);
	FPUTW(Nx,file);
	FPUTW(Ny,file);
	FPUTC(0x80|(8-1),file);

	for (b=0; b<SIZE; b++)
	for (g=0; g<SIZE; g++)
	for (r=0; r<SIZE; r++) top[b][g][r]=NULL;

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) {
	    for (ptr=(&(top[MASK(color.RGB[2]=pvB[y][x])]
			   [MASK(color.RGB[1]=pvG[y][x])]
			   [MASK(color.RGB[0]=pvR[y][x])]));
		(list=(*ptr))!=NULL && list->color.code!=color.code;
		 ptr=(&(list->next))) ;

	    if (list!=NULL)
		++(list->COUNT);
	    else {
		if ((*ptr=list=(List *)malloc(sizeof(*list)))==NULL)
		    Error("list memory allocation");

		list->color=color; list->COUNT=1; list->next=NULL; ++old;
	    }
	}
	if (old<=256)
	    for (b=0; b<SIZE; b++)
	    for (g=0; g<SIZE; g++)
	    for (r=0; r<SIZE; r++)
		for (list=top[b][g][r]; list!=NULL; list=list->next) {
		    FPUTC(list->color.RGB[0],file);
		    FPUTC(list->color.RGB[1],file);
		    FPUTC(list->color.RGB[2],file); list->INDEX=new++;
		}
	else {
	    if ((LUT=(List **)malloc(old*sizeof(*LUT)))==NULL)
		Error("LUT memory allocation");

	    old=0;
	    for (b=0; b<SIZE; b++)
	    for (g=0; g<SIZE; g++)
	    for (r=0; r<SIZE; r++)
		for (list=top[b][g][r]; list!=NULL; list=list->next)
		    LUT[old++]=list;

	    for (i=0; i<256; i++) cube[i].count=0;

	    l=0; u=old; width=Rp=Gp=Bp=128; Rb=Gb=Bb=0;

#define REGISTER(lower,upper,Rbase,Gbase,Bbase)	{ \
	Register(cube,LUT,lower,upper,width,Rbase,Gbase,Bbase); ++new; \
}

	    for (;;) {
		B=Bisect(LUT,l,u,2,Bp);
		if (l<B) {
		    G=Bisect(LUT,l,B,1,Gp);
		    if (l<G) {
			R=Bisect(LUT,l,G,0,Rp);
			if (l<R) REGISTER(l,R,Rb,Gb,Bb);
			if (R<G) REGISTER(R,G,Rp,Gb,Bb);
		    }
		    if (G<B) {
			R=Bisect(LUT,G,B,0,Rp);
			if (G<R) REGISTER(G,R,Rb,Gp,Bb);
			if (R<B) REGISTER(R,B,Rp,Gp,Bb);
		    }
		}
		if (B<u) {
		    G=Bisect(LUT,B,u,1,Gp);
		    if (B<G) {
			R=Bisect(LUT,B,G,0,Rp);
			if (B<R) REGISTER(B,R,Rb,Gb,Bp);
			if (R<G) REGISTER(R,G,Rp,Gb,Bp);
		    }
		    if (G<u) {
			R=Bisect(LUT,G,u,0,Rp);
			if (G<R) REGISTER(G,R,Rb,Gp,Bp);
			if (R<u) REGISTER(R,u,Rp,Gp,Bp);
		    }
		}
		if (new>256+1-8) break;

		c=0;
		for (i=0; i<256; i++)
		    if (cube[i].count>c && cube[i].width>1) c=cube[j=i].count;

		if (c==0) break;

		cube[j].count=0; l=cube[j].lower;
				 u=cube[j].upper;
				 width=(UCHAR)(cube[j].width/2);
				 Rp=(UCHAR)((Rb=cube[j].Rbase)+width);
				 Gp=(UCHAR)((Gb=cube[j].Gbase)+width);
				 Bp=(UCHAR)((Bb=cube[j].Bbase)+width); --new;
	    }
	    new=0;
	    for (i=0; i<256; i++)
		if (cube[i].count!=0) {
		    Rs=Gs=Bs=0.0;
		    for (k=cube[i].lower; k<cube[i].upper; k++) {
			list=LUT[k];
			count=(double)list->COUNT;
			Rs+=((double)list->color.RGB[0]*count);
			Gs+=((double)list->color.RGB[1]*count);
			Bs+=((double)list->color.RGB[2]*count);
			list->INDEX=new;
		    }
		    count=(double)cube[i].count;
		    FPUTC((UCHAR)(Rs/count+0.5),file);
		    FPUTC((UCHAR)(Gs/count+0.5),file);
		    FPUTC((UCHAR)(Bs/count+0.5),file); ++new;
		}

	    free(LUT);
	}
	for (; new<256; new++) {
	    FPUTC(0,file);
	    FPUTC(0,file);
	    FPUTC(0,file);
	}
	InitEncode(file);

	for (y=0; y<Ny; y++)
	for (x=0; x<Nx; x++) {
	    for (list=top[MASK(color.RGB[2]=pvB[y][x])]
			 [MASK(color.RGB[1]=pvG[y][x])]
			 [MASK(color.RGB[0]=pvR[y][x])];
		 list->color.code!=color.code;
		 list=list->next) ;

	    Encode(list->INDEX,file);
	}
	TermEncode(file);

	for (b=0; b<SIZE; b++)
	for (g=0; g<SIZE; g++)
	for (r=0; r<SIZE; r++)
	    for (list=top[b][g][r]; list!=NULL; list=next) {
		next=list->next; free(list);
	    }
}
