
#include <stdlib.h>

extern void	Error();

#define WORD	unsigned short

typedef struct List {
		WORD		h,v;
		struct List	*next;
	} List;

static void	(*Store)();

#define ALLOC(type,noe)	(type *)malloc((size_t)(noe)*sizeof(type))

static void	Flush(list,fore)
List		*list;
long		fore;
{
	size_t	idx,cnt=0;
	List	**array,**head,**tail,*oList,*nList,*stack=list;
	int	oSide,nSide,h0,v0,h1,v1,h2,v2;

	while ((list=list->next)!=NULL) ++cnt;

	if ((array=ALLOC(List *,cnt))==NULL)
	    Error("array memory allocation error.");

	list=stack;
	for (idx=0; idx<cnt; idx++) {
	    array[idx]=list; list=list->next;
	}
	free(list);

	stack->next=NULL;

	head=array+1; tail=array+cnt-1;
	if ((*head)->v>(*tail)->v) {
	    oSide=0; oList=(*(head++));
	}
	else {
	    oSide=1; oList=(*(tail--));
	}
	while (head!=tail) {
	    if ((*head)->v>(*tail)->v) {
		nSide=0; nList=(*(head++));
	    }
	    else {
		nSide=1; nList=(*(tail--));
	    }

#define STORE_AND_POP() \
	(*Store)((int)stack->h/2,(int)stack->v/2, \
		 (int)oList->h/2,(int)oList->v/2, \
		 (int)nList->h/2,(int)nList->v/2,fore); \
	oList=stack; if ((stack=stack->next)==NULL) break

	    if (oSide==nSide) {
		h1=oList->h-(h0=nList->h);
		v1=oList->v-(v0=nList->v);
		if (oSide==0)
		    for (; v1*(h2=stack->h-h0)>
			   h1*(v2=stack->v-v0); h1=h2,
						v1=v2) { STORE_AND_POP(); }
		else /* if (oSide==1) */
		    for (; v1*(h2=stack->h-h0)<
			   h1*(v2=stack->v-v0); h1=h2,
						v1=v2) { STORE_AND_POP(); }
	    }
	    else {
		list=oList; for (;;) { STORE_AND_POP(); }
		oList=list;
	    }
	    oList->next=stack; stack=oList; oList=nList; oSide=nSide;
	}
	nList=(*head); for (;;) { STORE_AND_POP(); }

	for (idx=0; idx<cnt; idx++) free(array[idx]); free(array);
}

static List	*Alloc(h,v,next)
int		h,v;
List		*next;
{
	List	*list=ALLOC(List,1);

	if (list==NULL) Error("list memory allocation error.");

	list->h=(WORD)h; list->v=(WORD)v; list->next=next; return list;
}

static List	*hori,**vert,**help,**ptr;

static void	Corner(h,v,lu,ld,ru,rd)
int		h,v;
long		lu,ld,ru,rd;
{
	List	*temp,*next;

#define VERT	vert[h]
#define HELP	help[h]

	switch(((lu&1)?8:0)|((ld&1)?4:0)|((ru&1)?2:0)|((rd&1)?1:0)) {
	    case 0x1:
		VERT=Alloc(h,v+1,Alloc(h,v,hori=Alloc(h+1,v,NULL)));
		ptr=(&HELP);
		break;
	    case 0x2:
		VERT->v=(WORD)v;
		next=HELP->next;
		if (HELP->h==next->h && HELP->v==next->v) {
		    hori=Alloc(h+1,v,Alloc(h,v,next));
		    HELP->next=Alloc(h,v,NULL); Flush(VERT,(long)(ru>>1));
		}
		else
		    hori=Alloc(h+1,v,VERT);
		break;
	    case 0x3:
		ptr=(&HELP);
		break;
	    case 0x4:
		hori->h=(WORD)h; hori->next=VERT=Alloc(h,v+1,NULL);
		*ptr=hori;
		break;
	    case 0x7:
		hori->h=(WORD)h; VERT->v=(WORD)v;
		next=HELP->next;
		if (HELP->h==next->h && HELP->v==next->v) {
		    hori->next=Alloc(h,v,next);
		    HELP->next=Alloc(h,v,NULL); Flush(VERT,(long)(rd>>1));
		}
		else
		    hori->next=VERT;
		*ptr=hori;
		break;
	    case 0x8:
		VERT->v=(WORD)v; hori->h=(WORD)h; Flush(hori,(long)(lu>>1));
		break;
	    case 0xb:
		hori->h=(WORD)h; VERT=Alloc(h,v+1,hori);
		ptr=(&HELP); HELP=hori;
		break;
	    case 0xd:
		VERT->v=(WORD)v;
		temp=(*ptr); next=temp->next;
		if (temp->h==next->h && temp->v==next->v) {
		    Flush(Alloc(h,v,next),(long)(ld>>1));
		    temp->next=Alloc(h,v,hori=Alloc(h+1,v,NULL));
		}
		else
		    VERT->next=hori=Alloc(h+1,v,NULL);
		break;
	    case 0xe:
		temp=(*ptr); next=temp->next;
		if (temp->h==next->h && temp->v==next->v)
		    hori=Alloc(h+1,v,Alloc(h,v,next));
		else
		    hori=Alloc(h+1,v,Alloc(h,v,Alloc((int)temp->h,
						     (int)temp->v,next)));
		*ptr=temp->next=Alloc(h,v,VERT=Alloc(h,v+1,NULL));
		break;
	}
}

static long	*u1,*d1,*u2,*d2;

void	InitTriangulation(Nh,Nv,back,fore)
int	Nh,Nv;
char	***back;
long	***fore;
{
	char	*wmae="work memory allocation error.";
	int	v;

	if ((vert=ALLOC(List *,Nh*2+1))==NULL ||
	    (help=ALLOC(List *,Nh*2+1))==NULL ||
	    (u1=ALLOC(long,Nh+1))==NULL ||
	    (d1=ALLOC(long,Nh+1))==NULL ||
	    (u2=ALLOC(long,Nh*2+1))==NULL ||
	    (d2=ALLOC(long,Nh*2+1))==NULL ||
	    (*back=ALLOC(char *,Nv))==NULL ||
	    (*fore=ALLOC(long *,Nv))==NULL) Error(wmae);

	++u1; ++d1; ++u2; ++d2;

	for (v=0; v<Nv; v++)
	    if (((*back)[v]=ALLOC(char,Nh))==NULL ||
		((*fore)[v]=ALLOC(long,Nh))==NULL) Error(wmae);
}

void	Triangulation(hl,vu,hr,vd,back,fore,store)
int	hl,vu,hr,vd;
char	**back;
long	**fore;
void	(*store)();
{
	int	h1,h2,v1,v2;
	long	rd;

	Store=store;

	h1=hl-1; h2=hl*2-1; u1[h1]=d1[h1]=u2[h2]=d2[h2]=0;

	for (h2=(h1=hl)*2; h1<=hr; h1++, h2+=2) d1[h1]=d2[h2]=d2[h2+1]=0;

	for (v2=(v1=vu)*2; v1<=vd; v1++, v2+=2) {
	    for (h2=(h1=hl)*2; h1<=hr; h1++, h2+=2) {
		u1[h1]=d1[h1];
		if (!back[v1][h1]) {
		    rd=d1[h1]=1|fore[v1][h1]<<1;
		    if (rd==u1[h1]) {
			u2[h2]=(rd==u1[h1-1] && rd==d1[h1-1])?rd:0; u2[h2+1]=rd;
		    }
		    else
			u2[h2]=u2[h2+1]=0;
		}
		else
		    d1[h1]=u2[h2]=u2[h2+1]=0;

		Corner(h2,v2,d2[h2-1],u2[h2-1],d2[h2],u2[h2]);
		Corner(h2+1,v2,d2[h2],u2[h2],d2[h2+1],u2[h2+1]);
	    }
	    Corner(h2,v2,d2[h2-1],u2[h2-1],0L,0L);

	    for (h2=(h1=hl)*2; h1<=hr; h1++, h2+=2) {
		rd=d2[h2+1]=d1[h1]; d2[h2]=(rd && rd==d1[h1-1])?rd:0;

		Corner(h2,v2+1,u2[h2-1],d2[h2-1],u2[h2],d2[h2]);
		Corner(h2+1,v2+1,u2[h2],d2[h2],u2[h2+1],d2[h2+1]);
	    }
	    Corner(h2,v2+1,u2[h2-1],d2[h2-1],0L,0L);
	}
	for (h2=(h1=hl)*2; h1<=hr; h1++, h2+=2) {
	    Corner(h2,v2,d2[h2-1],0L,d2[h2],0L);
	    Corner(h2+1,v2,d2[h2],0L,d2[h2+1],0L);
	}
	Corner(h2,v2,d2[h2-1],0L,0L,0L);
}

void	TermTriangulation(Nv,back,fore)
int	Nv;
char	**back;
long	**fore;
{
	int	v;

	for (v=Nv-1; v>=0; v--) {
	    free(fore[v]); free(back[v]);
	}
	free(fore); free(back); free(d2-1); free(u2-1);
				free(d1-1); free(u1-1); free(help); free(vert);
}
