
#include <stdio.h>
#include <stdlib.h>

extern void	Error();

#define WORD	unsigned short

typedef struct {
		WORD	hi,vi,hj,vj,hk,vk,d;
#ifdef	__BORLANDC__
		WORD	pad;
#endif
	} Trigon;

static char	*STL="facet normal %d %d %d\n"
		     "outer loop\nvertex %d %d %d\n"
				 "vertex %d %d %d\n"
				 "vertex %d %d %d\nendloop\nendfacet\n";

#define PRINT(function,nx,ny,nz,xi,yi,zi,xj,yj,zj,xk,yk,zk)	\
	static void	function(t) \
	Trigon		*t; \
	{ \
		(void)printf(STL,nx,ny,nz,(int)t->xi,(int)t->yi,(int)t->zi, \
					  (int)t->xj,(int)t->yj,(int)t->zj, \
					  (int)t->xk,(int)t->yk,(int)t->zk); \
	}

PRINT(Mx,-1, 0, 0,d ,hi,vi,d ,hj,vj,d ,hk,vk)
PRINT(Px, 1, 0, 0,d ,hi,vi,d ,hj,vj,d ,hk,vk)
PRINT(My, 0,-1, 0,vi,d ,hi,vj,d ,hj,vk,d ,hk)
PRINT(Py, 0, 1, 0,vi,d ,hi,vj,d ,hj,vk,d ,hk)
PRINT(Mz, 0, 0,-1,hi,vi,d ,hj,vj,d ,hk,vk,d )
PRINT(Pz, 0, 0, 1,hi,vi,d ,hj,vj,d ,hk,vk,d )

#define PATH_LEN	1024

static void	Scan(prefix,suffix,print)
char		*prefix,*suffix;
void		(*print)();
{
	char	path[PATH_LEN];
	FILE	*file;
	Trigon	t;

	(void)sprintf(path,"%s.%s_s",prefix,suffix);
	if ((file=fopen(path,"rb"))==NULL) {
	    (void)fputs(path,stderr); Error(" : VM file not found.");
	}
	while (fread(&t,sizeof(Trigon),(size_t)1,file)==1) (*print)(&t);
/*
	while (!feof(file)) {
	    if (fread(&t,sizeof(Trigon),(size_t)1,file)!=1) {
		(void)fputs(path,stderr); Error(" : trigon data read error.");
	    }
	    (*print)(&t);
	}
*/
	(void)fclose(file);
}

int	main(argc,argv)
int	argc;
char	**argv;
{
	if (argc!=2) Error("usage : vm_s_stl VM");

	(void)puts("solid"); Scan(argv[1],"mx",Mx);
			     Scan(argv[1],"px",Px);
			     Scan(argv[1],"my",My);
			     Scan(argv[1],"py",Py);
			     Scan(argv[1],"mz",Mz);
			     Scan(argv[1],"pz",Pz); (void)puts("endsolid");

	return 0;
}
